"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LaTeXProcessor = void 0;
const latex_to_ast_1 = require("./latex-to-ast");
class LaTeXProcessor {
    constructor(config = {}) {
        this.config = config;
    }
    availableExtensions() {
        return [".tex", ".cls"].concat(this.config.extensions || []);
    }
    processor() {
        return {
            preProcess(text) {
                return latex_to_ast_1.parse(text);
            },
            postProcess(messages, filePath) {
                return {
                    messages,
                    filePath: filePath ? filePath : "<latex>",
                };
            },
        };
    }
}
exports.LaTeXProcessor = LaTeXProcessor;
